/* Author: Jeff Dalton <J.Dalton@ed.ac.uk>
 * Updated: Tue Feb 26 16:38:45 2008 by Jeff Dalton
 * Copyright: (c) 2008, AIAI, University of Edinburgh
 */

package ix.icore;

import ix.icore.log.EventLogger;

/**
 * Lets us change protected fields of IXAgents.
 */
public class IXAgentAccessor {

    private Accessor accessor = new Accessor();

    public IXAgentAccessor() {
    }

    public void setEventLogger(IXAgent a, EventLogger logger) {
	accessor.setEventLogger(a, logger);
    }

    /**
     * A hidden IXAgent that does the work for us.
     */
    private static class Accessor extends IXAgent {

	private Accessor() {
	    super(false);		// not standalone main agent
	}

	private void setEventLogger(IXAgent a, EventLogger logger) {
	    a.eventLogger = logger;
	}

    }

}
